/*
	Œ삷SSDLabSNESAPUpSCRIPT700p[T[

	lIɂ̓RpCnƃJIXV[h点Ηǂ̂Ŏ𔲂Ă܂
	ʂ̂ŋClĂ(w

	G[Ɏvア
	gR}h͑S`FbNĂȂ
	ʏR}hm,w,a,e,braȊOقƂǃ`FbNĂȂ

	...̂œScript700gƂ͒

	CZX͈ꉞLGPLĎ
 */

#include "script700_parser.h"
#include <windows.h>

bool script700_parser::load(file_info *info)
{
	// .700ɕύX
	string8 file_name = info->get_file_path();
	int num = file_name.find_last('.');
	file_name.remove_chars(num+1, file_name.length()-num);
	file_name.add_string("700");
	reader *s700 = file::g_open_read(file_name);
	if (s700) {
		m_aScriptBuf.set_size((unsigned int)s700->get_length() + 1);
		m_aScriptBuf.zeromemory();
		s700->read(m_aScriptBuf, (unsigned int)s700->get_length());
		s700->reader_release_safe();
		return true;
	}

	// 65816.700t@C
	num = file_name.find_last('\\');
	int num2 = file_name.find_last('|');
	num = (num>num2)?num:num2;
	file_name.remove_chars(num+1, file_name.length()-num);
	file_name.add_string("65816.700");
	s700 = file::g_open_read(file_name);
	if (s700) {
		m_aScriptBuf.set_size((unsigned int)s700->get_length() + 1);
		m_aScriptBuf.zeromemory();
		s700->read(m_aScriptBuf, (unsigned int)s700->get_length());
		s700->reader_release_safe();
		return true;
	}

	if (m_pProgram) {
		m_pProgram[0] = 0x0;
	}
	return false;
}

script700_parser::script700_parser()
{
	m_pProgram = m_pDSPFlag = m_pChange = NULL;
	m_pWork = m_pDetune = NULL;
}

script700_parser::script700_parser(u8 *&pProgram, u32 *&pWork, u8 *&pDSPFlag, u8 *&pChange, u32 *&pDetune)
	 : m_bExtendFlag(false),
	   m_program_index(0)
{
	m_pProgram = pProgram;
	m_pWork    = pWork;
	m_pDSPFlag = pDSPFlag;
	m_pChange  = pChange;
	m_pDetune  = pDetune;
	ZeroMemory(m_aLabel, sizeof(m_aLabel));
}

void* script700_parser::get_ptr()
{
	if (m_aScriptBuf.get_size() == 0) {
		return NULL;
	}
	return m_aScriptBuf.get_ptr();
}

char* script700_parser::skip_space(char *&ptr)
{
	while (1) {
		if (*ptr != ' ' && *ptr != '\t') break;
		if (*ptr == '\0') break;
		ptr++;
	}
	return ptr;
}

int script700_parser::get_num(char *&ptr)
{
	int loop_flag = 1, n = 0, radix = 10;
	skip_space(ptr);
	while (loop_flag) {
		switch (*ptr) {
		  case 'A':	case 'B':	case 'C':
		  case 'D':	case 'E':	case 'F':
			if (radix < 16) {
				loop_flag = 0;
				break;
			}
			n = n * radix + (*(ptr++) - 'A' + 10);
			break;
		  case 'a':	case 'b':	case 'c':
		  case 'd':	case 'e':	case 'f':
			if (radix < 16) {
				loop_flag = 0;
				break;
			}
			n = n * radix + (*(ptr++) - 'a' + 10);
			break;
		  case '2':	case '3':	case '4':	case '5':
		  case '6':	case '7':	case '8':	case '9':
			if (radix < 10) {
				loop_flag = 0;
				break;
			}
		  case '0':	case '1':
			n = n * radix + (*(ptr++) - '0');
			break;
		  default:
			loop_flag = 0;
			break;
		}
	}

	return n;
}


char* script700_parser::next_line(char *&ptr)
{
	while (1) {
		if (*ptr==0x0a || *ptr==0x0d) {
			if (*ptr == 0x0a) ptr++;
			break;
		}
		if (*ptr == '\0') break;
		ptr++;
	}
	return ptr;
}

// obt@0ŏIĂ邱ƂO
bool script700_parser::parse ()
{
	char *ptr = m_aScriptBuf.get_ptr();
	ZeroMemory(m_pWork, 4*4);

	while (*ptr) {

		while (*ptr && (*ptr==0x0a || *ptr==0x0d)) {
			ptr++;
		}

		get_line(ptr);
	}
	
	return true;
}


char* script700_parser::get_line(char *&p_ptr)
{
	while (*p_ptr) {
		skip_space(p_ptr);
		if (*p_ptr == 0x0a || *p_ptr == 0x0d) break;
		if (m_bExtendFlag == false) {
			get_command(p_ptr);
		} else {
			get_ex_command(p_ptr);
		}
	}
	return p_ptr;
}

char* script700_parser::get_command(char *&p_ptr)
{
	// normal command
	switch (*p_ptr) {
	  case ':':
		if (*(p_ptr+1) == ':') {
			// "::"gR}hJn
			m_bExtendFlag = true;
		} else {
			// x
			int num = get_num(++p_ptr);
			m_aLabel[num] = m_program_index;
		}
		break;
	  case 'w':
	  case 'W':
		m_pProgram[m_program_index++] = 0x01;
		get_value(++p_ptr, 0);
		break;
	  case 'm':
	  case 'M':
		m_pProgram[m_program_index++] = 0x02;
		get_value(++p_ptr, 1);
		get_value(p_ptr, 2);
		break;
	  case 'a':
	  case 'A':
		m_pProgram[m_program_index++] = 0x04;
		m_pProgram[m_program_index++] = 0x00;
		get_value(++p_ptr, 1);
		get_value(p_ptr, 2);
		break;
	  case 'c':
	  case 'C':
		m_pProgram[m_program_index++] = 0x03;
		get_value(++p_ptr, 1);
		get_value(p_ptr, 2);
		break;
	  case 's':
	  case 'S':
		m_pProgram[m_program_index++] = 0x04;
		m_pProgram[m_program_index++] = 0x01;
		get_value(++p_ptr, 1);
		get_value(p_ptr, 2);
		break;
	  case 'u':
	  case 'U':
		m_pProgram[m_program_index++] = 0x04;
		m_pProgram[m_program_index++] = 0x02;
		get_value(++p_ptr, 1);
		get_value(p_ptr, 2);
		break;
	  case 'd':
	  case 'D':
		m_pProgram[m_program_index++] = 0x04;
		m_pProgram[m_program_index++] = 0x03;
		get_value(++p_ptr, 1);
		get_value(p_ptr, 2);
		break;
	  case 'e':
	  case 'E':
		// gR}hJn
		m_bExtendFlag = true;
		p_ptr++;
		break;
	  case 'b':
	  case 'B':
		{
			int old_index = m_program_index;
			// Jump
			// bra/beq/bge/ble/bgt/blt/bcc/blc/bhi/bcs
			if ((*(p_ptr+1) == 'r' || *(p_ptr+1) == 'R') &&
				(*(p_ptr+2)== 'a'  || *(p_ptr+2)== 'A')) {
				m_pProgram[m_program_index++] = 0x05;
			}
			if ((*(p_ptr+1) == 'e' || *(p_ptr+1) == 'E') &&
				(*(p_ptr+2)== 'q'  || *(p_ptr+2)== 'Q')) {
				m_pProgram[m_program_index++] = 0x06;
			}
			if ((*(p_ptr+1) == 'n' || *(p_ptr+1) == 'N') &&
				(*(p_ptr+2)== 'e'  || *(p_ptr+2)== 'E')) {
				m_pProgram[m_program_index++] = 0x07;
			}
			if ((*(p_ptr+1) == 'g' || *(p_ptr+1) == 'G') &&
				(*(p_ptr+2)== 'e'  || *(p_ptr+2)== 'E')) {
				m_pProgram[m_program_index++] = 0x08;
			}
			if ((*(p_ptr+1) == 'l' || *(p_ptr+1) == 'L') &&
				(*(p_ptr+2)== 'e'  || *(p_ptr+2)== 'E')) {
				m_pProgram[m_program_index++] = 0x09;
			}
			if ((*(p_ptr+1) == 'g' || *(p_ptr+1) == 'G') &&
				(*(p_ptr+2)== 't'  || *(p_ptr+2)== 'T')) {
				m_pProgram[m_program_index++] = 0x0A;
			}
			if ((*(p_ptr+1) == 'l' || *(p_ptr+1) == 'L') &&
				(*(p_ptr+2)== 't'  || *(p_ptr+2)== 'T')) {
				m_pProgram[m_program_index++] = 0x0B;
			}
			if ((*(p_ptr+1) == 'c' || *(p_ptr+1) == 'C') &&
				(*(p_ptr+2)== 'c'  || *(p_ptr+2)== 'C')) {
				m_pProgram[m_program_index++] = 0x0C;
			}
			if ((*(p_ptr+1) == 'l' || *(p_ptr+1) == 'L') &&
				(*(p_ptr+2)== 'o'  || *(p_ptr+2)== 'O')) {
				m_pProgram[m_program_index++] = 0x0D;
			}
			if ((*(p_ptr+1) == 'h' || *(p_ptr+1) == 'H') &&
				(*(p_ptr+2)== 'i'  || *(p_ptr+2)== 'I')) {
				m_pProgram[m_program_index++] = 0x0E;
			}
			if ((*(p_ptr+1) == 'c' || *(p_ptr+1) == 'C') &&
				(*(p_ptr+2)== 's'  || *(p_ptr+2)== 'S')) {
				m_pProgram[m_program_index++] = 0x0F;
			}

			if (old_index != m_program_index) {
				p_ptr += 3;
				int num = get_num(p_ptr);
				m_pProgram[m_program_index++] = (u8)m_aLabel[num];
				m_pProgram[m_program_index++] = (u8)(m_aLabel[num] >> 8);
			} else {
				// R}h
				next_line(p_ptr);
			}
		}
		  break;
	  case ';':
		// comment
		next_line(p_ptr);
		break;

/*---------------------------------------*/
//ȉ얢mF
	  case 'n':
	  case 'N':
		{
			m_pProgram[m_program_index++] = 0x04;
			int type;
			if (*p_ptr == '#') {type = 0; p_ptr++;}
			if (*p_ptr == 'w') {type = 2; p_ptr++;}
			int num = get_num(++p_ptr);
			skip_space(p_ptr);
			switch(*p_ptr) {
			  case '+':
				m_pProgram[m_program_index++] = 0x00;
				break;
			  case '-':
				m_pProgram[m_program_index++] = 0x01;
				break;
			  case '*':
				m_pProgram[m_program_index++] = 0x02;
				break;
			  case '/':
				m_pProgram[m_program_index++] = 0x03;
				break;
			  case '%':
				m_pProgram[m_program_index++] = 0x04;
				break;
			  case '&':
				m_pProgram[m_program_index++] = 0x05;
				break;
			  case '|':
				m_pProgram[m_program_index++] = 0x06;
				break;
			  case '^':
				m_pProgram[m_program_index++] = 0x07;
				break;
			  case '<':
				m_pProgram[m_program_index++] = 0x08;
				break;
			  case '>':
				m_pProgram[m_program_index++] = 0x09;
				break;
			}
			m_pProgram[m_program_index++] = type;
			if (type == 0) {
				m_pProgram[m_program_index++] = (u8)num;
				m_pProgram[m_program_index++] = (u8)(num >> 8);
				m_pProgram[m_program_index++] = (u8)(num >> 16);
				m_pProgram[m_program_index++] = (u8)(num >> 24);
			} else {
				m_pProgram[m_program_index++] = (u8)num;
			}
			get_value(++p_ptr, 2);
		}
		break;
/*---------------------------------------*/
	  default:
		// mȂR}h͖
		next_line(p_ptr);
		break;
	}
	return p_ptr;
}

char* script700_parser::get_ex_command(char *&p_ptr)
{
	switch (*p_ptr) {
	  case 'm':
	  case 'M':
		// mute
		p_ptr++;
		skip_space(p_ptr);
		if (*p_ptr == '!') {
			for (int i=0; i <= 255; i++) {
				m_pDSPFlag[i] ^= 0x01;
			}
		} else {
			int num = get_num(p_ptr);
			m_pDSPFlag[num] ^= 0x01;
		}
		break;
	  case 'c':
	  case 'C':
		{
			int num = get_num(++p_ptr);
			m_pDSPFlag[num] |= 0x02;
			int num2 = get_num(p_ptr);
			m_pChange[num] = num2;
		}
		break;
	  case 'd':
	  case 'D':
		{
			int num = get_num(++p_ptr);
			m_pDSPFlag[num] |= 0x04;
			int num2 = get_num(p_ptr);
			m_pDetune[num] = num2;
			p_ptr++;
		}
		break;
	  case 'e':
	  case 'E':
		// p[XI
		p_ptr++;
		break;
	  default:
		// mȂR}h͖
		next_line(p_ptr);
		break;
	}
	return p_ptr;
}

bool script700_parser::get_value(char *&p_ptr, int type)
{
	int num;
	skip_space(p_ptr);
	switch (*p_ptr) {
	  case '#':
		m_pProgram[m_program_index++] = 0x00;
		num = get_num(++p_ptr);
		// 4byte
		m_pProgram[m_program_index++] = (u8)num;
		m_pProgram[m_program_index++] = (u8)(num >> 8);
		m_pProgram[m_program_index++] = (u8)(num >> 16);
		m_pProgram[m_program_index++] = (u8)(num >> 24);
		break;
	  case 'w':
	  case 'W':
		m_pProgram[m_program_index++] = 0x02;
		num = get_num(++p_ptr);
		// 1byte
		m_pProgram[m_program_index++] = (u8)num;
		break;
	  default:
		if (*p_ptr < '0' && *p_ptr > '9') return false;

		m_pProgram[m_program_index++] = 0x01;
		num = get_num(p_ptr);
		if (type == 0) {
			// 4byte
			m_pProgram[m_program_index++] = (u8)num;
			m_pProgram[m_program_index++] = (u8)(num >> 8);
			m_pProgram[m_program_index++] = (u8)(num >> 16);
			m_pProgram[m_program_index++] = (u8)(num >> 24);
		} else {
			// 1byte
			m_pProgram[m_program_index++] = (u8)num;
		}
		break;
	}
	return true;
}
